/*
 Bengol compiler ASCI INPUT
 MAY 24 2020

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "beng.h"
 /*  file and file i/o */
 FILE * fout, * fina, *finb;
 void * fin;
 char namein[14];
 char name1[14];
 char name2[14];
 char line[82],token[13];
 /* token read and line read in*/
 short int look,reread,looksz;
 long int lookv;
 int lp,asmm,lineno,nomore;
 int inblock; /* true if in block */

/* Symbol table */
/* n symbols ~ 8 char symbol + null*/

 char  sstr[SSYMAX];      /* string names */
 char  stag[SYMAX];       /* tag          */
 char  ssz[SYMAX];       /* size 0 word 1 byte */
 char  sstk[SYMAX];       /* stack 0 page zero 1 stack 3 stk + base */
 short int sst[SYMAX],    /* string index */
 sleft[SYMAX],sright[SYMAX],/* left right pointers */
 sdimp[SYMAX];  /* dimension or operation prority or struct offset */
 long int sval[SYMAX]; /* value or symbol offset     */

/* table lookup and table pointers */

 int nxt,nxts,rxt,rxts;

 int root; /* root ptr for add symbol */
 int rops; /* tokens and symbols */
 int rcon; /* constants */
 int rvar; /* variables  static */
 int rloc,rnxts; /* variables  local  */
/* compiler variables   */
 int labn,zpage;
 long int org;
 int argc,stk,bcc;
 int verbose;   /* 1 output list tty 2 output list asm 3 both */
 int inpar,neg;  /* inside () negate flag */
/* string table */

 char litq[2050]; /* string table */
 int strptr,strlab; /* pointer and label */
 int litptr,litlab;
 /* operand table  */
 /* op op tag 
    opa op value 
    taga leafa  variable or base index
    sz size 0 1
    stk 0 1 sp 3 sp+base
    idx <>0 id structure off structure offset
	tagb leafb  index
    tabnext next operand in the table
*/

 int tstart; /* start of table */
 int topx,tmpx;   /* table index , local temp */
 short int tabop[TERMAX],tabopa[TERMAX],tabtaga[TERMAX],tabtagb[TERMAX];
 char  tabsza[TERMAX], tabstka[TERMAX], tabszb[TERMAX], tabstkb[TERMAX];
 char  tabrec[TERMAX];
 /* struct index a, offset a */
 short int taboff[TERMAX];
 long int  tableafa[TERMAX],tableafb[TERMAX];
 short int tabnxt[TERMAX];

/* proto types */
void look1();
void over(char *s);
void bad(char *s );
void doblock(int jc,int jb);
void cblock(int i,int jc,int jb);
void getsub();
void getpar(int flg);

#include "beng1.c"    /* low level IO and token routines */
#include "beng2.c"    /* low level parsing routines */
#include "beng3.c"    /* code generation */
#include "beng4.c"    /* recusive decent compiler low level*/
#include "beng5.c"    /* recusive decent compiler high level*/
