/* Input token / utility  functions */
/* get next label */

int nlab()
{ labn=labn+1; return labn;}

 /* print label */
plab(int l)
{
fprintf(fout,"?%d\n",l);
}
/* goto label */ 
pjump()
{
fprintf(fout,"_%s\n",token);
}
pgoto()
{
fprintf(fout,"  JMP A #_%s\n",token);
}

/* table overflow error*/

void over(char *s)
{
printf("Line # %d %s Table Overflow \n",lineno,s);
if(fout!=NULL) fclose(fout);
if(fina!=NULL)  fclose(fina);
if(finb!=NULL)  fclose(finb);
exit(0);
}
/*  skip matching token like ] */

match(int m)
{
look1(); /* this token */
if(look!=m) bad("Wrong Token");  /* error */
look=Tnoop; /* no op */
}


/* add name to name string table*/
void addname(char *s)
{ int i;
  i=0;
  while(s[i])
  {
  sstr[nxts]=s[i];
  i=i+1;nxts=nxts+1;
  }
 sstr[nxts]=0;
 nxts=nxts+1;
 if((nxts+16)>=SSYMAX) over("String Name");
}

/* add symbol to root ptr */
void adsym(char *s,short int tag,long int value)
{
int m,i,rt,r;
r = root;

if(r)
 {
 while(r){
  i = sst[r];
 /* match string */

  m=strcmp(s,&sstr[i]);
  if(m==0)
   bad("Dup Symbol");
  if(m<0){
   rt=sleft[r];
   if(rt==0) sleft[r]=nxt;
   }
  else{
   rt=sright[r];
   if(rt==0)
   sright[r]=nxt;
   }
  r=rt;
  }
 }
else root=nxt;

/* add node */
 sleft[nxt]=0;
 sright[nxt]=0;
 stag[nxt]=tag;
 ssz[nxt]=0; /* size 0 word 1 byte */
 sstk[nxt]=0; /* 0 normal 1 stk 3 sp+base */
 sval[nxt]=value;
 sst[nxt]=nxts;
 sdimp[nxt]=0;
 addname(s);

 nxt=nxt+1;
 if(nxt>=SYMAX) over("Symbol table");

}
//* find symbol returning table index */
int findsym(char *s,int r)
{
int m,i;
 if(r==0) return 0;
 while(r){
  i = sst[r];
 /* match string */
  m=strcmp(s,&sstr[i]);
  if(m==0) return r;
  if(m<0)
   r=sleft[r];
  else
   r=sright[r];
  }
 return r;
}

/* look up operand or symbol string */

void look1(){
int r,prefix;
/* did we back up? */
if (reread) { reread=0;return;}
prefix=0;
looksz=0;
/* read input stream */
 getoken();
 if(look!=Tid && look!=Tsub) return;
 r=findsym(token,rops);
 if(r==0) { /* check for defined constant */
   r=findsym(token,rcon);
   if(r==0) return;
   /* found constant */
   look=Tnum;lookv=sval[r];looksz=ssz[r];
   return;  
   }

 if(stag[r]== Tun) /* unsigned prefix */
  {
  getoken();
  r=findsym(token,rops);
  if(r==0) bad("Operand expected");
  prefix=8;
  }
  lookv=sval[r]+prefix;
  look=stag[r];
  if(inblock && look>=Tint && look<=Tchar) look=Tnum;   
}



/* constant lookup  {-} # */
void look2(int check)
{
int m,ch;
long v;
look1(); 
if(check && look!=Tnum) { reread=1; return; }
v=lookv;
ch=unary();
while(ch)
 {
 look1();look1();
 if(look!=Tnum) bad("Constant expected");
 if(ch=='+') v=v+lookv;
 if(ch=='*') v=v*lookv;
 ch=unary();
 }
lookv = v;
return ;

}
/* variable routines */

int qvar() /* variable  r if found */
{
 int r;
 r=0;
 if(look==Tid)
  { r=findsym(token,rloc);
    if(r==0)
     { r=findsym(token,rvar);
       if(r==0)bad("Undefined Variable");
     }
  }
return r;
}
/* true if [ */
int islb()
{
return line[lp]=='[';
}
